#AutoIt3Wrapper_Run_Obfuscator=y
#Obfuscator_Parameters=/sf /sv /om /cs=0 /cn=0
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Change2CUI=y
#AutoIt3Wrapper_Res_Description=Head displays n bytes from the header of a file
#AutoIt3Wrapper_Res_Fileversion=0.6.5.0
#AutoIt3Wrapper_Res_LegalCopyright=UEZ 2011
#AutoIt3Wrapper_Res_Language=1033
#AutoIt3Wrapper_Res_Field=Coded by|UEZ
#AutoIt3Wrapper_Res_Field=Build|2011-03-15 beta
#AutoIt3Wrapper_Res_Field=Compile date|%longdate% %time%
#AutoIt3Wrapper_Res_Field=AutoIt Version|%AutoItVer%
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_UPX_Parameters=--ultra-brute --crp-ms=999999 --all-methods --all-filters
#AutoIt3Wrapper_Run_After=del /f /q "%scriptdir%\%scriptfile%_Obfuscated.au3"
#AutoIt3Wrapper_Run_After=Upack.exe %out% -c6 -f273 -red
;~ #AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6

Opt("MustDeclareVars", 1)
#include <EditConstants.au3>
#include <File.au3>
#include <GUIConstantsEx.au3>
#include <Process.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>

Global Const $name = "Head ", $ver = "v0.65 ", $build = "Build 2011-03-15 beta ", $coder = "by UEZ"
Global $filename, $bytes = 512, $gui = False, $save = False, $hGUI, $hEdit, $i, $var

If _ProcessGetName(_WinAPI_GetParentProcess(@AutoItPID)) = "cmd.exe" Then
	If Not $CmdLine[0] Then Help()
	CheckParameter()
Else
	$var = WinList()
	For $i = 1 To $var[0][0]
		If $var[$i][0] <> "" And BitAND(WinGetState($var[$i][1]), 2) Then
			If WinGetProcess($var[$i][0], "") = @AutoItPID Then
				WinSetState($var[$i][1], "", @SW_HIDE)
				ExitLoop
			EndIf
		EndIf
	Next
	GUI(0)
EndIf

If $gui Then
	GUI($filename)
Else
	PrintHeadofFile($filename)
EndIf
Exit

Func GUI($filename)
	Local $nMsg
	If Not $filename Then
		$filename = FileOpenDialog("Select a file", "", "All Files (*.*)")
		If @error Then Exit MsgBox(16, "Error", "No file selected! Closing...", 10)
	Else
		If Not FileExists($filename) Then Exit MsgBox(16, "ERROR ", $filename & " not found! Please check filename and try again.")
	EndIf
	$hGUI = GUICreate($name & $ver & $build & $coder, 800, 600)
	$hEdit = GUICtrlCreateEdit("", 0, 0, 800, 600, BitOR($ES_AUTOVSCROLL, $ES_AUTOHSCROLL, $ES_READONLY, $WS_HSCROLL, $WS_VSCROLL))
	GUICtrlSendMsg($hEdit, $EM_LIMITTEXT,  -1, 0)
	GUICtrlSetFont($hEdit, 12, 400, 0, "Courier New")
	GUICtrlSetBkColor($hEdit, 0xFFFFFF)
	GUISetState(@SW_SHOW)
	$gui = True
	PrintHeadofFile($filename)
	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				Exit
		EndSwitch
	WEnd
EndFunc   ;==>GUI

Func PrintHeadofFile($filename)
	Local $data, $em, $hSave
	Local Const $fsize = FileGetSize($filename)
	If FileGetSize($filename) < $bytes Then $bytes = $fsize
	If $bytes > 0x7FFFFF Then $bytes = 512
	Local $hFile = FileOpen($filename, 0)
	If $hFile = -1 Then
		$em = "ERROR: unable to open file. The file may has been locked by another process."
		If Not $gui Then
			ConsoleWrite(@CRLF & $em & @CRLF & @CRLF)
			Exit
		Else
			GUICtrlSetData($hEdit, $em)
			Return
		EndIf
	EndIf
	$data = FileRead($hFile, $bytes)
	FileClose($hFile)
	If Not $gui Then
		ConsoleWrite(@CRLF & $data & @CRLF & @CRLF)
	Else
		GUICtrlSetData($hEdit, $data)
	EndIf
	If $save Then
		$hSave = FileOpen($save, 2)
		If $hSave = -1 Then Exit ConsoleWrite(@CRLF & "ERROR: " & $save &  " could not be created!" & @CRLF & @CRLF)
		FileWrite($hSave, $data)
		FileClose($hSave)
	EndIf
	$data = ""
EndFunc

;~ Func PrintHeadOfFile($filename)
;~ 	Local $nBytes, $data, $em, $hSave
;~ 	Local Const $fsize = FileGetSize($filename)
;~ 	If FileGetSize($filename) < $bytes Then $bytes = $fsize
;~ 	If $bytes > 0x7FFFFF Then $bytes = 512
;~ 	Local $tBuffer = DllStructCreate("byte[" & $bytes & "]")
;~ 	Local $hFile = _WinAPI_CreateFile($filename, 2, 7)
;~ 	ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $hFile = ' & $hFile & @crlf & '>Error code: ' & @error & @crlf) ;### Debug Console
;~ 	If Not $hFile Then
;~ 		$em = "ERROR: unable to open file. The file may has been locked by another process."
;~ 		If Not $gui Then
;~ 			ConsoleWrite(@CRLF & $em & @CRLF & @CRLF)
;~ 			Exit
;~ 		Else
;~ 			GUICtrlSetData($hEdit, $em)
;~ 			Return
;~ 		EndIf
;~ 	EndIf
;~ 	_WinAPI_SetFilePointer($hFile, 0)
;~ 	_WinAPI_ReadFile($hFile, DllStructGetPtr($tBuffer), $bytes, $nBytes)
;~ 	_WinAPI_CloseHandle($hFile)
;~ 	$data = BinaryToString(DllStructGetData($tBuffer, 1))
;~ 	$tBuffer = ""
;~ 	If Not $gui Then
;~ 		ConsoleWrite(@CRLF & $data & @CRLF & @CRLF)
;~ 	Else
;~ 		GUICtrlSetData($hEdit, $data)
;~ 	EndIf
;~ 	If $save Then
;~ 		$hSave = FileOpen($save, 2)
;~ 		If $hSave = -1 Then Exit ConsoleWrite(@CRLF & "ERROR: " & $save &  " could not be created!" & @CRLF & @CRLF)
;~ 		FileWrite($hSave, $data)
;~ 		FileClose($hSave)
;~ 	EndIf
;~ EndFunc   ;==>PrintHeadOfFile

Func CheckParameter()
	Local $i, $u = UBound($CmdLine)
	If $CmdLine[1] = "-v" Then Version()
	If $CmdLine[1] = "-h" Then Help()
	If $u = 2 Then Help()
	While $i < $u
		If $i < $u - 1 Then
			If $CmdLine[$i] = "-f" Then $filename = $CmdLine[$i + 1]
			If $CmdLine[$i] = "-b" Then $bytes = $CmdLine[$i + 1]
			If $CmdLine[$i] = "-s" Then $save = $CmdLine[$i + 1]
		EndIf
		If $CmdLine[$i] = "-g" Then $gui = True
		$i += 1
	WEnd
	If $bytes < 1 Then Help()
	If $filename = "" Then Exit ConsoleWrite(@CRLF & "ERROR:  Value for parameter -f is missing!" & @CRLF & @CRLF)
	If Not FileExists($filename) Then Exit ConsoleWrite(@CRLF & "ERROR: " & $filename & " not found! Please check filename and try again." & @CRLF & @CRLF)
	$filename = _PathFull($filename)
EndFunc   ;==>CheckParameter

Func Help()
	ConsoleWrite(@CRLF & _
		"Usage:" & @TAB & _
		"Head -f <file to load> [-b <bytes>] [-s filename to save] [-g] [-h] [-v]" & @CRLF & @CRLF & @CRLF & _
		"Mandatory:" & @CRLF & @CRLF & _
		@TAB & "-f" & @TAB & "<file to open>" & @CRLF & @CRLF & _
		"Options:" & @CRLF & @CRLF & _
		@TAB & "-b" & @TAB & "Bytes to read from beginning of the file. Default is " & $bytes & "." & @CRLF & @TAB & @TAB & "Must be greater than 0 and smaller than 8MB!" & @CRLF & _
		@TAB & "-s" & @TAB & "Save output to a file. If file already exists it will be" & @CRLF & @TAB & @TAB & "overwritten  without confirmation!" & @CRLF & _
		@TAB & "-g" & @TAB & "Enable GUI using commandline parameter" & @CRLF & _
		@TAB & "-h" & @TAB & "Displays this page" & @CRLF & _
		@TAB & "-v" & @TAB & "program version information" & @CRLF & @CRLF)
	Exit
EndFunc   ;==>Help

Func Version()
	ConsoleWrite(@CRLF & $name & $ver & $build & $coder & @CRLF & @CRLF & @CRLF)
	Exit
EndFunc   ;==>Version

Func _WinAPI_GetParentProcess($PID = 0) ;from WinAPIEx.au3 by Yashied
	If Not $PID Then
		$PID = _WinAPI_GetCurrentProcessID()
		If Not $PID Then
			Return SetError(1, 0, 0)
		EndIf
	EndIf
	Local $hSnapshot = DllCall('kernel32.dll', 'ptr', 'CreateToolhelp32Snapshot', 'dword', 0x00000002, 'dword', 0)
	If (@error) Or (Not $hSnapshot[0]) Then
		Return SetError(1, 0, 0)
	EndIf
	Local $tPROCESSENTRY32 = DllStructCreate('dword Size;dword Usage;dword ProcessID;ulong_ptr DefaultHeapID;dword ModuleID;dword Threads;dword ParentProcessID;long PriClassBase;dword Flags;wchar ExeFile[260]')
	Local $pPROCESSENTRY32 = DllStructGetPtr($tPROCESSENTRY32)
	Local $Ret, $Result = 0
	$hSnapshot = $hSnapshot[0]
	DllStructSetData($tPROCESSENTRY32, 'Size', DllStructGetSize($tPROCESSENTRY32))
	$Ret = DllCall('kernel32.dll', 'int', 'Process32FirstW', 'ptr', $hSnapshot, 'ptr', $pPROCESSENTRY32)
	While (Not @error) And ($Ret[0])
		If DllStructGetData($tPROCESSENTRY32, 'ProcessID') = $PID Then
			$Result = DllStructGetData($tPROCESSENTRY32, 'ParentProcessID')
			ExitLoop
		EndIf
		$Ret = DllCall('kernel32.dll', 'int', 'Process32NextW', 'ptr', $hSnapshot, 'ptr', $pPROCESSENTRY32)
	WEnd
	_WinAPI_CloseHandle($hSnapshot)
	If Not $Result Then
		Return SetError(1, 0, 0)
	EndIf
	Return $Result
EndFunc   ;==>_WinAPI_GetParentProcess